// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments and the horrible code structure. I will fix
// this soon. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

abstract class Character
{
  Vector              position;
  CharacterScaffold   scaffold;
  final float         k = 0.2;

  Character
    ( Vector position )
  {
    this.position = position;
  }

  void setScaffold
    ( CharacterScaffold scaffold )
  {
    this.scaffold = scaffold;
  }

  abstract void draw();
}

class CharacterA extends Character
{
  CharacterA
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y, px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y );
    line( px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y, px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y );
    line( px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y, px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y );
    line( px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
    line( px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y, px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y );
  }
}

class CharacterB extends Character
{
  CharacterB
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y );
    line( px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y, px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y );
    line( px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y, px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y );
    line( px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y, px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y );
    line( px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y, px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y );
    line( px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y, px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y );
  }
}

class CharacterC extends Character
{
  CharacterC
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y, px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y );
    line( px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y, px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y );
    line( px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y, px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y );
    line( px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y, px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y );
    line( px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
  }
}


class CharacterD extends Character
{
  CharacterD
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y );
    line( px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y, px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y );
    line( px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y, px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y );
    line( px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y, px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y );
    line( px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y, px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y );
  }
}

class CharacterE extends Character
{
  CharacterE
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
    line( px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
  }
}

class CharacterF extends Character
{
  CharacterF
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y );
    line( px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
  }
}

class CharacterG extends Character
{
  CharacterG
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y );
    line( px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y, px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y );
    line( px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
    line( px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
  }
}

class CharacterH extends Character
{
  CharacterH
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
    line( px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
  }
}

class CharacterI extends Character
{
  CharacterI
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
    line( px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[4].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
  }
}

class CharacterJ extends Character
{
  CharacterJ
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
    line( px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
    line( px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[4].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
    line( px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y, px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y );
    line( px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y, px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y );
  }
}

class CharacterK extends Character
{
  CharacterK
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y, px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y );
    line( px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
  }
}

class CharacterL extends Character
{
  CharacterL
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
  }
}

class CharacterM extends Character
{
  CharacterM
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
    line( px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
  }
}

class CharacterN extends Character
{
  CharacterN
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
  }
}

class CharacterO extends Character
{
  CharacterO
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y, px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y );
    line( px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y, px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y );
    line( px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y, px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y );
    line( px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y, px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y );
    line( px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y, px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y );
    line( px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y, px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y );
    line( px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y, px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y );
  }
}

class CharacterP extends Character
{
  CharacterP
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y );
    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y, px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y );
    line( px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
  }
}

class CharacterQ extends Character
{
  CharacterQ
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y, px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y );
    line( px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y, px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y );
    line( px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
    line( px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y, px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y );
    line( px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y, px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y );
    line( px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y, px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y );
    line( px, py, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
  }
}

class CharacterR extends Character
{
  CharacterR
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y );
    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[9].x, py + k * scaffold.vertices[9].y, px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y );
    line( px + k * scaffold.vertices[10].x, py + k * scaffold.vertices[10].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
  }
}


class CharacterS extends Character
{
  CharacterS
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[8].x, py + k * scaffold.vertices[8].y );
    line( px + k * scaffold.vertices[15].x, py + k * scaffold.vertices[15].y, px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y );
    line( px + k * scaffold.vertices[7].x, py + k * scaffold.vertices[7].y, px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[5].x, py + k * scaffold.vertices[5].y, px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y );
    line( px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y, px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y );
    line( px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
  }
}

class CharacterT extends Character
{
  CharacterT
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
    line( px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[4].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
  }
}

class CharacterU extends Character
{
  CharacterU
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y );
    line( px + k * scaffold.vertices[14].x, py + k * scaffold.vertices[14].y, px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y );
    line( px + k * scaffold.vertices[13].x, py + k * scaffold.vertices[13].y, px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y );
    line( px + k * scaffold.vertices[12].x, py + k * scaffold.vertices[12].y, px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y );
    line( px + k * scaffold.vertices[11].x, py + k * scaffold.vertices[11].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
  }
}

class CharacterV extends Character
{
  CharacterV
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
    line( px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
  }
}

class CharacterW extends Character
{
  CharacterW
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y );
    line( px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y, px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[4].y );
    line( px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[4].y, px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y );
    line( px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y, px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y );
  }
}

class CharacterX extends Character
{
  CharacterX
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y, px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[2].x, py + k * scaffold.vertices[2].y, px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[3].x, py + k * scaffold.vertices[3].y, px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[5].y );
  }
}

class CharacterY extends Character
{
  CharacterY
    ( Vector position )
  {
    super( position );
  }

  void draw
    ()
  {
    float px = position.x;
    float py = position.y;

    line( px + k * scaffold.vertices[0].x, py + k * scaffold.vertices[0].y, px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[1].x, py + k * scaffold.vertices[1].y, px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[5].y );
    line( px + k * scaffold.vertices[4].x, py + k * scaffold.vertices[5].y, px + k * scaffold.vertices[6].x, py + k * scaffold.vertices[6].y );
  }
}
