// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments and the horrible code structure. I will fix
// this soon. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

class ScaffoldEditor
{
  Vector              position;
  
  DraggableLine       heightTop;
  DraggableLine       divHorizontal;
  DraggableLine       heightBottom;
  DraggableLine       widthLeft;
  DraggableLine       divVertical;
  DraggableLine       widthRight;  
  
  DraggableLine       sub0;
  DraggableLine       sub1;
  DraggableLine       sub2;
  DraggableLine       sub3;
  
  CharacterScaffold   scaffold;
  
  ScaffoldEditor
  ( Vector position,
    float  extent )
  {
    this.position      = position;
    
    float px           = position.x;
    float py           = position.y;
    
    heightTop          = new DraggableLine( 
                          new Vector( px - extent/2, py - extent/2, 0 ), 
                          new Vector( px + extent/2, py - extent/2, 0 ), 
                          new Vector( 0, 1, 0 ),
                          new Vector( px - extent/2, py - extent/2, 0 ),
                          new Vector( px + extent/2, py, 0 ) );
    divHorizontal      = new DraggableLine( 
                          new Vector( px - extent/2, py, 0 ), 
                          new Vector( px + extent/2, py, 0 ), 
                          new Vector( 0, 1, 0 ),
                          new Vector( px - extent/2, py - extent/2, 0 ),
                          new Vector( px + extent/2, py + extent/2, 0 ) );
    heightBottom       = new DraggableLine( 
                          new Vector( px - extent/2, py + extent/2, 0 ), 
                          new Vector( px + extent/2, py + extent/2, 0 ), 
                          new Vector( 0, 1, 0 ),
                          new Vector( px - extent/2, py, 0 ),
                          new Vector( px + extent/2, py + extent/2, 0 ) );
    widthLeft          = new DraggableLine( 
                          new Vector( px - extent/2, py - extent/2, 0 ), 
                          new Vector( px - extent/2, py + extent/2, 0 ), 
                          new Vector( 1, 0, 0 ),
                          new Vector( px - extent/2, py - extent/2, 0 ),
                          new Vector( px, py + extent/2, 0 ) );
    divVertical        = new DraggableLine( 
                          new Vector( px, py - extent/2, 0 ), 
                          new Vector( px, py + extent/2, 0 ), 
                          new Vector( 1, 0, 0 ),
                          new Vector( px - extent/2, py - extent/2, 0 ),
                          new Vector( px + extent/2, py + extent/2, 0 ) );
    widthRight         = new DraggableLine( 
                          new Vector( px + extent/2, py - extent/2, 0 ), 
                          new Vector( px + extent/2, py + extent/2, 0 ), 
                          new Vector( 1, 0, 0 ),
                          new Vector( px, py - extent/2, 0 ),
                          new Vector( px + extent/2, py + extent/2, 0 ) );
                          
    sub0               = new DraggableLine( 
                          new Vector( px + extent/8, py - 5*extent/8, 0 ), 
                          new Vector( px + 5*extent/8, py - extent/8, 0 ), 
                          new Vector( 1, -1, 0 ),
                          new Vector( px, py - 3*extent/4, 0 ),
                          new Vector( px + extent/4, py - extent/2, 0 ) );
                          
    sub1               = new DraggableLine( 
                          new Vector( px + extent/8, py + 5*extent/8, 0 ), 
                          new Vector( px + 5*extent/8, py + extent/8, 0 ), 
                          new Vector( 1, 1, 0 ),
                          new Vector( px, py + extent/2, 0 ),
                          new Vector( px + extent/4, py + 3*extent/4, 0 ) );
                          
    sub2               = new DraggableLine( 
                          new Vector( px - extent/8, py + 5*extent/8, 0 ), 
                          new Vector( px - 5*extent/8, py + extent/8, 0 ), 
                          new Vector( 1, -1, 0 ),
                          new Vector( px - extent/4, py + extent/2, 0 ),
                          new Vector( px, py + 3*extent/4, 0 ) );
                          
    sub3               = new DraggableLine( 
                          new Vector( px - extent/8, py - 5*extent/8, 0 ), 
                          new Vector( px - 5*extent/8, py - extent/8, 0 ), 
                          new Vector( 1, 1, 0 ),
                          new Vector( px - extent/4, py - 3*extent/4, 0 ),
                          new Vector( px, py - extent/2, 0 ) );
                          
    scaffold = new CharacterScaffold();
    updateScaffold();
      
    for ( int i=0; i<gCharacters.length; i++ )
    {
      gCharacters[i].setScaffold( scaffold );
    }
  }
  
  void update
  ( Cursor cursor )
  {
    boolean token = false;
    
    float px = position.x;
    float py = position.y;
    
    token = heightTop.update( cursor, token );
    token = heightBottom.update( cursor, token );
    token = widthLeft.update( cursor, token );
    token = widthRight.update( cursor, token );
    token = divHorizontal.update( cursor, token );
    token = divVertical.update( cursor, token );
    
    token = sub0.update( cursor, token );
    token = sub1.update( cursor, token );
    token = sub2.update( cursor, token );
    token = sub3.update( cursor, token );
    
    if ( cursor.pressed )
    {
      widthLeft.p1.y        = heightTop.p1.y;
      widthRight.p1.y       = heightTop.p1.y;
      widthLeft.p2.y        = heightBottom.p1.y;
      widthRight.p2.y       = heightBottom.p1.y;
      heightTop.p1.x        = widthLeft.p1.x;
      heightBottom.p1.x     = widthLeft.p1.x;
      heightTop.p2.x        = widthRight.p1.x;
      heightBottom.p2.x     = widthRight.p1.x;
      
      divHorizontal.p1.x    = divVertical.min.x = heightTop.p1.x;
      divHorizontal.p2.x    = divVertical.max.x = heightTop.p2.x;
      divVertical.p1.y      = divHorizontal.min.y = widthLeft.p1.y;
      divVertical.p2.y      = divHorizontal.max.y = widthLeft.p2.y;
      
      updateScaffold();

      for ( int i=0; i<gCharacters.length; i++ )
      {
        gCharacters[i].setScaffold( scaffold );
      }
      
      freshDraw();
    }
  }
  
  void draw
  ()
  {
    float px = position.x;
    float py = position.y;
    
    strokeWeight( 10 );
    stroke( 230 );
    ellipse( px, py, 10, 10 );
    
    heightTop.draw();
    divHorizontal.draw();
    heightBottom.draw();
    widthLeft.draw();
    divVertical.draw();
    widthRight.draw();
    
    sub0.draw();
    sub1.draw();
    sub2.draw();
    sub3.draw();
  }
  
  void updateScaffold
  ()
  {
    float px = position.x;
    float py = position.y;
    
    scaffold.vertices[0].set( heightTop.p1.x - px, heightTop.p1.y - py, 0 );
    scaffold.vertices[1].set( heightTop.p2.x - px, heightTop.p2.y - py, 0 );
    scaffold.vertices[2].set( heightBottom.p2.x - px, heightBottom.p2.y - py, 0 );
    scaffold.vertices[3].set( heightBottom.p1.x - px, heightBottom.p1.y - py, 0 );
    scaffold.vertices[4].set( divVertical.p1.x - px, divVertical.p1.y - py, 0 );
    scaffold.vertices[5].set( divHorizontal.p2.x - px, divHorizontal.p2.y - py, 0 );
    scaffold.vertices[6].set( divVertical.p2.x - px, divVertical.p2.y - py, 0 );
    scaffold.vertices[7].set( divHorizontal.p1.x - px, divHorizontal.p1.y - py, 0 );
    
    Vector i1 = heightTop.intersect( sub0 );
    Vector i2 = widthRight.intersect( sub0 );
    Vector i3 = widthRight.intersect( sub1 );
    Vector i4 = heightBottom.intersect( sub1 );
    Vector i5 = heightBottom.intersect( sub2 );
    Vector i6 = widthLeft.intersect( sub2 );
    Vector i7 = widthLeft.intersect( sub3 );
    Vector i8 = heightTop.intersect( sub3 );
    
    scaffold.vertices[8].set( i8.x - px, i8.y - py, 0 );
    scaffold.vertices[9].set( i1.x - px, i1.y - py, 0 );
    scaffold.vertices[10].set( i2.x - px, i2.y - py, 0 );
    scaffold.vertices[11].set( i3.x - px, i3.y - py, 0 );
    scaffold.vertices[12].set( i4.x - px, i4.y - py, 0 );
    scaffold.vertices[13].set( i5.x - px, i5.y - py, 0 );
    scaffold.vertices[14].set( i6.x - px, i6.y - py, 0 );
    scaffold.vertices[15].set( i7.x - px, i7.y - py, 0 );
    
    if ( scaffold.vertices[8].x < scaffold.vertices[0].x )
    {
      scaffold.vertices[8].x = scaffold.vertices[15].x = scaffold.vertices[0].x;
      scaffold.vertices[8].y = scaffold.vertices[15].y = scaffold.vertices[0].y;
    } 
    
    if ( scaffold.vertices[9].x > scaffold.vertices[1].x )
    {
      scaffold.vertices[9].x = scaffold.vertices[10].x = scaffold.vertices[1].x;
      scaffold.vertices[9].y = scaffold.vertices[10].y = scaffold.vertices[1].y;
    } 
    
    if ( scaffold.vertices[12].x > scaffold.vertices[2].x )
    {
      scaffold.vertices[12].x = scaffold.vertices[11].x = scaffold.vertices[2].x;
      scaffold.vertices[12].y = scaffold.vertices[11].y = scaffold.vertices[2].y;
    } 
    
    if ( scaffold.vertices[13].x < scaffold.vertices[3].x )
    {
      scaffold.vertices[13].x = scaffold.vertices[14].x = scaffold.vertices[3].x;
      scaffold.vertices[13].y = scaffold.vertices[14].y = scaffold.vertices[3].y;
    } 
  }
}
