// ------------------------------------------------------------------------------
// http://www.arkitus.com
// Copyright (C) 2008  Ali Eslami
// 
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// ------------------------------------------------------------------------------
// Apologies for the lack of comments and the horrible code structure. I will fix
// this soon. If you have any questions feel free to email me at:
// ali@arkitus.com
// ------------------------------------------------------------------------------

float              DRAGGABLE_SNAP             = 10;
int                GRID_COLUMNS               = 5;

Cursor             gCursor;
ScaffoldEditor     gEditor;
Character[]        gCharacters;
boolean            gHasInited = false;

void setup
()
{
  size( 800, 420 );
  background( 255, 255, 255 );
  
  gCursor = new Cursor();
  gCharacters = new Character[25];
  
  float widthIncrement = 500.0f / ((float) GRID_COLUMNS + 1 );
  float heightIncrement = 340.0f / ((float) ((int) (26.0f / GRID_COLUMNS)));
 
  gCharacters[0] = new CharacterA( new Vector( widthIncrement, heightIncrement, 0 ) );
  gCharacters[1] = new CharacterB( new Vector( 2 * widthIncrement, heightIncrement, 0 ) );
  gCharacters[2] = new CharacterC( new Vector( 3 * widthIncrement, heightIncrement, 0 ) );
  gCharacters[3] = new CharacterD( new Vector( 4 * widthIncrement, heightIncrement, 0 ) );
  gCharacters[4] = new CharacterE( new Vector( 5 * widthIncrement, heightIncrement, 0 ) );
  gCharacters[5] = new CharacterF( new Vector( widthIncrement, 2 * heightIncrement, 0 ) );
  gCharacters[6] = new CharacterG( new Vector( 2 * widthIncrement, 2 * heightIncrement, 0 ) );
  gCharacters[7] = new CharacterH( new Vector( 3 * widthIncrement, 2 * heightIncrement, 0 ) );
  gCharacters[8] = new CharacterI( new Vector( 4 * widthIncrement, 2 * heightIncrement, 0 ) );
  gCharacters[9] = new CharacterJ( new Vector( 5 * widthIncrement, 2 * heightIncrement, 0 ) );
  gCharacters[10] = new CharacterK( new Vector( widthIncrement, 3 * heightIncrement, 0 ) );
  gCharacters[11] = new CharacterL( new Vector( 2 * widthIncrement, 3 * heightIncrement, 0 ) );
  gCharacters[12] = new CharacterM( new Vector( 3 * widthIncrement, 3 * heightIncrement, 0 ) );
  gCharacters[13] = new CharacterN( new Vector( 4 * widthIncrement, 3 * heightIncrement, 0 ) );
  gCharacters[14] = new CharacterO( new Vector( 5 * widthIncrement, 3 * heightIncrement, 0 ) );
  gCharacters[15] = new CharacterP( new Vector( widthIncrement, 4 * heightIncrement, 0 ) );
  gCharacters[16] = new CharacterQ( new Vector( 2 * widthIncrement, 4 * heightIncrement, 0 ) );
  gCharacters[17] = new CharacterR( new Vector( 3 * widthIncrement, 4 * heightIncrement, 0 ) );
  gCharacters[18] = new CharacterS( new Vector( 4 * widthIncrement, 4 * heightIncrement, 0 ) );
  gCharacters[19] = new CharacterT( new Vector( 5 * widthIncrement, 4 * heightIncrement, 0 ) );
  gCharacters[20] = new CharacterU( new Vector( widthIncrement, 5 * heightIncrement, 0 ) );
  gCharacters[21] = new CharacterV( new Vector( 2 * widthIncrement, 5 * heightIncrement, 0 ) );
  gCharacters[22] = new CharacterW( new Vector( 3 * widthIncrement, 5 * heightIncrement, 0 ) );
  gCharacters[23] = new CharacterX( new Vector( 4 * widthIncrement, 5 * heightIncrement, 0 ) );
  gCharacters[24] = new CharacterY( new Vector( 5 * widthIncrement, 5 * heightIncrement, 0 ) );
  
  gEditor = new ScaffoldEditor( new Vector( 635, 210, 0 ), 180 );
  
  smooth();
}

void draw
()
{
  if ( !gHasInited ) {
    freshDraw();
    gHasInited = true;
  }
  
  gCursor.update();
  gEditor.update( gCursor );
}

void freshDraw
()
{
  background( 255 );
  
  strokeCap( PROJECT );
  
  gEditor.draw();
  
  strokeWeight( 3 );
  stroke( 0 );
  strokeCap( ROUND );
  
  for ( int i=0; i<gCharacters.length; i++ )
  {
    gCharacters[i].draw();
  }
}

void mousePressed
()
{
  gCursor.pressed = true;
}

void mouseReleased
()
{
  gCursor.pressed = false;
}
